# Название:      Круг от края
# Сайт:            http://stroyka.in 
# Дата:           16.05.2011  
# Автор:         Sahi (г.Рязань)
# Описание:  Скрипт рисует окружность от края.
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#
                                          
class Risuem_krug_otkraya
                                          
   def initialize
     
     @krug = false
     @folofme = false
     @erase = false
     @segment = 24 if not defined? @segment
#     cursor = Sketchup.find_support_file("cursor.png","Plugins/krug_Icons/")
#		 @cursor = UI::create_cursor(cursor, 1, 24)         # MV instead of @@cursor
  end
 # -------             # -------               # -------
# def onSetCursor
#	 UI::set_cursor(@cursor)     # MV instead of @@cursor
# end
# -------             # -------               # -------
  def create_krug_otkraya(pts)
     @krug = true
     model=Sketchup.active_model
     begin
     model.start_operation("Circle >>>", true)
     rescue
     model.start_operation("Circle >>>")
     end
     entities=model.active_entities
     group = entities.add_group
     ents = group.entities
    
   if(@folofme)
     curve = ents.add_curve(pts) + ents.add_edges(pts.first,@pt0,pts.last)
     faces = ents.add_face(curve)
     faces.reverse!.followme @curve
     @folofme = false
    else
     curve = ents.add_curve pts if @curve 
     ents.add_face curve if @curve
     unless @curve 
       @curve = ents.add_curve pts 
       ents.add_face @curve
      end
    end
     Sketchup.active_model.commit_operation
     #Sketchup.active_model.select_tool(nil)
     self.reset
  end
# -------             # -------               # -------
def increment_state
   begin
    case @state
    when 1
      @krug = false
      @ip1.copy! @ip
      Sketchup::set_status_text "Specify the end point of the circle ©" #  "Укажите конечную точку окружности ©"
      @vlevo = @vpravo = @vverh = @vniz = true
    when 2
      @radius = @length/2
      @pt0 = @pts[0].offset(@yvec, @radius)
      @ptt = Array.new
      @ptt[0] = @pts[0]
      @xvec = @ptt[0] - @pt0
       @cvec = @xvec.cross @zvec
      trans  = Geom::Transformation.rotation(@pt0,@zvec,@angle.degrees)
      1.upto(@segment.to_i){@ptt.push @ptt.last.transform(trans)}
     @ptt.freeze
      self.create_krug_otkraya(@ptt)
    end
    rescue
    puts "#"
    end
  end
 # -------             # -------               # ------- 
def getExtents
   bbox = Geom::BoundingBox.new
   bbox.add(@ip.position)if @ip and @ip.valid?
   bbox.add(@pts) if @pts[1] != nil
   return bbox
 end
 # -------             # -------               # -------
  def reset
     @ip = Sketchup::InputPoint.new
     @ip1 = Sketchup::InputPoint.new
     @drawn = false
     @pts = Array.new
     @state = 0
     @length = 0
     @angle = nil
      Sketchup::set_status_text "Sides ", SB_VCB_LABEL  # "Сегментов "
      Sketchup::set_status_text @segment.to_s, SB_VCB_VALUE
     Sketchup::set_status_text("Set the parameters of the circle (number of segments)", SB_PROMPT)  # ("Задайте параметры круга (количество сегментов) ©"
    end
# ========================================= #                                               
  def activate
    self.reset
  end
# ========================================= #
# ========================================= #                                                 
  def deactivate(view)
    view.invalidate if @drawn
    Sketchup.active_model.commit_operation
    Sketchup.active_model.select_tool(nil)
  end
# ========================================= #
def set_current_point(view)
    view.tooltip = @ip.tooltip
    need_draw = true
  case @state
  when 0
  @pth = Array.new
  @pth[0] = @pts[0] = @ip.position
  
  if(@sel)
     if(@sel[0].is_a?(Sketchup::Face))
      @planes = @sel[0].plane
      @zvec = @sel[0].normal
       @sel.clear
      elsif(@sel[1].is_a?(Sketchup::Face))
       @zvec = @sel[1].normal
       @sel.clear
      elsif(@sel[2].is_a?(Sketchup::Face))
        @zvec = @sel[2].normal
        @sel.clear  
       elsif(@sel[3].is_a?(Sketchup::Face))
        @zvec = @sel[3].normal
        @sel.clear
      else
        @zvec = Geom::Vector3d.new(0,0,1)
      end
      else
       @zvec = Geom::Vector3d.new(0,0,1)
     end

      vectr = @zvec.axes
      xvec = vectr.x
     @angle = 360.0/@segment.to_i
     
     size = view.pixels_to_model(20, @pth[0])
     @pt = @pth[0].offset(xvec, size)
      @ptg = @pth[0].offset(@zvec, size)
      
     trans  = Geom::Transformation.rotation(@pt,@zvec,@angle.degrees)
     1.upto(@segment.to_i){@pth.push @pth.last.transform(trans)}
     @planes = Geom.fit_plane_to_points @pth
  when 1
       @curve = false
       @ptt = Array.new
       pt = @ip.position
       @pts[1] = pt.project_to_plane @planes 
       @yvec =  @pts[1] - @pts[0]

      @length = @pts[0].distance @pts[1] #if @shift0
      
    if(@length != 0)
       @pt0 = @pts[0].offset(@yvec, @length/2) if(@yvec.length > 0)
         
      @ptt[0] = @pts[0]
      trans  = Geom::Transformation.rotation(@pt0,@zvec.reverse,@angle.degrees)
      0.upto(@segment.to_i){@ptt.push @ptt.last.transform(trans)}

      Sketchup::set_status_text "Diameter:   ", SB_VCB_LABEL  # "Диаметр "
      Sketchup::set_status_text @length.to_s, SB_VCB_VALUE
      end
    end
    view.invalidate if need_draw
  end
# -------             # -------               # -------  
  def draw(view)
    @drawn = false
    if( @ip.valid?)#&& @ip.display? )
      @ip.draw(view)
      
   case @state
    when 0
     view.line_width = 1
       view.set_color_from_line(@ptg,@pth[0])
        view.draw(GL_LINE_STRIP, @pth)
         view.draw_points @pth[0], 6, 2, "DarkViolet"
          @drawn = true
          
   when 1
    if(@length != 0)
      view.line_width=1
      view.set_color_from_line(@pts[0],@pts[1])
      view.draw(GL_LINE_STRIP, @pts)
      view.draw_points @pts[1], 6, 2, "DarkViolet"
        view.line_width = 2
         view.drawing_color =  "BlueViolet"
          view.draw(GL_LINE_STRIP, @ptt)
          
      @drawn = true
    end
  end
  end
  end 
# -------             # -------               # -------
  def onMouseMove(flags, x, y, view)
    if( !@ip.pick(view, x, y, @ip1) )
      return false
    end
    view.tooltip = @ip.tooltip
    ph=view.pick_helper
    ph.do_pick x,y
    @sel = ph.path_at(0)
    self.set_current_point(view)
  end
  # -------             # -------               # -------     
 def onLButtonDoubleClick(flags, x, y, view)
   Sketchup.active_model.select_tool(nil)
   end
# -------             # -------               # -------
def onLButtonDown(flags, x, y, view)
   @state += 1
    self.set_current_point(view)
    self.increment_state
    view.lock_inference
  end
# -------             # -------               # -------     
def onLButtonUp(flags, x, y, view)

  end
# -------             # -------               # -------  
def onCancel(flag, view)
    view.invalidate if @drawn
    self.reset
  end
 # -------             # -------               # -------
  def onUserText(text, view)
    begin
      value = text.to_l
    rescue
      UI.beep
      value = nil
      Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value

  case @state
    when 0
      @segment = text.to_i if(text.to_i > 2)
       self.set_current_point(view)
    when 1
      @state += 1
      @length = text.to_l
      self.increment_state
    end
  end
# -------             # -------               # -------
def onKeyDown(key, repeat, flags, view)
                 
  case key
    when 63234 # <---
      if(@krug and @vlevo)
        @vlevo = false
        ptt0 = Array.new
        trans  = Geom::Transformation.rotation(@pt0,@xvec,90.degrees)
        @ptt.each{|pt| ptt0.push pt.transform(trans)}
      self.create_krug_otkraya(ptt0)
    end
    when 63235  # -->
      if(@krug and @vpravo)
        @vpravo = false
        ptt0 = Array.new
        trans  = Geom::Transformation.rotation(@pt0,@cvec,90.degrees)
        @ptt.each{|pt| ptt0.push pt.transform(trans)}
      self.create_krug_otkraya(ptt0)
     end
    when 63232 # ^
      if(@krug and @vverh)  # @vlevo  @vpravo @vverh @vniz 
        @vverh = false
        @folofme = true
        ptt0 = Array.new
        ptt0.push @ptt[0]
        num =(@segment.to_i/4.0).ceil
        angle = 90.0/num
         num.times{
         trans0  = Geom::Transformation.rotation(@pt0,@cvec,angle.degrees)
         ptt0.push ptt0.last.transform(trans0)
         }
       self.create_krug_otkraya(ptt0)
      end
    when 63233 # v
      if(@krug and @vniz)
        @vniz = false
        @folofme = true
        ptt0 = Array.new
        ptt0.push @ptt[0]
        num =(@segment.to_i/4.0).ceil
        angle = 90.0/num
         num.times{
         trans0  = Geom::Transformation.rotation(@pt0,@cvec.reverse,angle.degrees)
         ptt0.push ptt0.last.transform(trans0)
         }
         ptt0.reverse!
       self.create_krug_otkraya(ptt0)
    end
  end
end
# -------             # -------               # -------
 def onKeyUp(key, rpt, flags, view)
     view.invalidate if @drawn
    if( key == CONSTRAIN_MODIFIER_KEY && view.inference_locked? )
      view.lock_inference
    end
   end
end # class
	if( not file_loaded?("krug.rb"))  
	#UI.menu("Plugins").add_item("Круг от грани"){ Sketchup.active_model.select_tool Risuem_krug_otkraya.new }
	UI.menu("Draw").add_item("Circle from edge"){ Sketchup.active_model.select_tool Risuem_krug_otkraya.new }
#----------------------------------------------------------------------------- By Defisto...xD!
	toolbar = UI::Toolbar.new("Circle by Diameter")
	path = File.dirname(__FILE__) + "/krug_Icons/"
#	toolbar.show
	toolbar.restore
#----------------------------------------------------------------------------- By Defisto...xD!
	cmd1 = UI::Command.new("Risuem_krug_otkraya.new" ) { Sketchup.active_model.select_tool Risuem_krug_otkraya.new }
	cmd1.small_icon = path + "CircleByDiameter_16.png"
	cmd1.large_icon = path + "CircleByDiameter_24.png"
	cmd1.tooltip = "Circle by Diameter (2 Points)"
	cmd1.status_bar_text ="Draw a Circle by its Diameter through the Designation of 2 Points"
	toolbar.add_item(cmd1)
#----------------------------------------------------------------------------- By Defisto...xD!
=begin
	UI.add_context_menu_handler do | menu |
	sel = Sketchup.active_model.selection
	if(sel[0].typename=="Edge")
	if(sel[0].curve)
		menu.add_separator
		menu.add_item("Add face circle"){ sel.each{|edg| edg.find_faces if edg.is_a? Sketchup::Edge}}
		end#if
	  end
   end
=end

end
# ------------------------ # 
file_loaded("krug.rb")
# =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= #